/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.internal;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.tooling.kernel.services.ICommandStackService;
import org.unicase.ecp.model.ECPWorkspaceManager;
import org.unicase.ecp.model.NoWorkspaceException;
import org.unicase.ecp.model.workSpaceModel.ECPProject;
import org.unicase.ui.common.commands.ECPCommand;

/**
 * This class implements the {@link ICommandStackService} interface.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @levd.rating RED Rev:
 */
public class CommandStackService implements ICommandStackService {

	/** {@inheritDoc} */
	@Override
	public void runAsCommand(final EObject target, final Runnable runner) {
		ECPProject project;
		try {
			project = ECPWorkspaceManager.getInstance().getWorkSpace()
					.getProject(target);
		} catch (NoWorkspaceException e) {
			return;
		}
		new ECPCommand(project.getRootObject()) {

			@Override
			protected void doRun() {
				runner.run();
			}
		}.run(false);
	}
}
